#include <cstdio>
#include <cstring>

using namespace std;


int main(void) {
	char * bug = new char[1002];
	int * stack = new int[2000001];
	char * output = new char[2000002];
	
	while(true) {
		int lines;
		int bugLen;
		char c;
		
		if(scanf("%d %s\n", &lines, bug) != 2) {
			break;
		}
		
		bugLen = strlen(bug);
		
		while(lines-- > 0) {
			int stackPos = -1;
			int outputLen = 0;
			
			c = getchar();
			
			while(c != '\n') {
				printf("stackPos = %d, stack value = %d, c = %c, outputLen = %d\n", stackPos, stackPos == -1 ? 0 : stack[stackPos], c, outputLen);
				
				if(stackPos > -1 && bug[stack[stackPos]] == c) {
					++stack[stackPos];
					printf("continue\n");
				}
				else if(bug[0] == c) {
					stack[++stackPos] = 1;
					printf("new stack\n");
				}
				else if(stackPos >= 0) {
					--stackPos;
					printf("remove stack\n");
					continue;
				}
				
				output[outputLen++] = c;
				
				if(stackPos > -1 && stack[stackPos] == bugLen) {
					printf("remove occurrence\n");
					outputLen -= bugLen;
					--stackPos;
				}
				
				c = getchar();
			}
			
			output[outputLen] = 0;
			
			printf("%s\n", output);
		}
	}
	
	delete [] bug;
	delete [] stack;
	delete [] output;
	
	return 0;
}
